/******************************************************************************
	hCount for use with the new Tilted Time Windows
	1st Algorithm
	01-NOV-2007
******************************************************************************/

#ifndef __HCWIN_
#define	__HCWIN_

#define WINDOWS	15
#define	INSERT	1
#define DELETE	-1

// macro that returns a random number in [v1, v2) 
#define random(v1,v2) (((double)(v1))+(((double)(v2)-((double)(v1)))*rand()/(RAND_MAX+1.0f)))

typedef struct hcWin {
	int c[WINDOWS*2+1];
} S_TYPE;

typedef struct win_type {
    long N;			// current transaction number
    S_TYPE **S;		// S[m][h] hash tables 
    int m, h;		// dimensions of the hash table array S 
    int *a, *b;		// a_i and b_i -> array of h random numbers 
    int P;			// the prime number used by the hashing function 
    long M;			// largest number in data stream 
} win_type;

extern void win_print(win_type * hc, int id);
extern win_type *win_init(double rho, double epsilon, long M);
extern void win_update(win_type *, int, int);
extern void win_destroy(win_type *);
extern int win_size(win_type *);
long win_query(win_type *hc, long val, long window, double alpha);

#endif
